-- Broker_CharacterTitles: Based on an idea by Kerecha over @ WoWAce.com

-- Zzzz, embeds & stuff, create DO etc...
local BRCharTitle = CreateFrame("Frame", "Broker_CharacterTitles")
local L = LibStub("AceLocale-3.0"):GetLocale("Broker_CharacterTitles", true)
BRCharTitle.obj = LibStub:GetLibrary("LibDataBroker-1.1"):NewDataObject("Broker_CharacterTitles", {type = "launcher", label = L["Character Titles"], icon = "Interface\\Icons\\INV_Scroll_04"})
LibStub("AceHook-3.0"):Embed(BRCharTitle)

-- events registration
BRCharTitle:RegisterEvent("PLAYER_ENTERING_WORLD")
BRCharTitle:RegisterEvent("KNOWN_TITLES_UPDATE")

BRCharTitle:SetScript("OnEvent", function(_, event, ...)
	BRCharTitle[event](BRCharTitle, ...)
end)

-- locals
local _G = getfenv(0)
local menuframe = CreateFrame("Frame", "Broker_CharacterTitle_Menu", UIParent, "UIDropDownMenuTemplate")
local numoftitles = 0

local function UpdateNumOfTitles()
local maxtitleID = GetNumTitles()
numoftitles = 0
	for i = 1, maxtitleID do
		if IsTitleKnown(i) ~= 0 then
			numoftitles = numoftitles + 1
		end
	end
end

local function DropdownInitFunction()
local info = {}
local isChecked
local maxtitleID = GetNumTitles()
local currentTitle = GetCurrentTitle()

-- build dropdown menu

-- add header
if numoftitles > 0 then	
	info.text = L["Character Titles"]
	info.notClickable = 1
	info.isTitle = 1
	UIDropDownMenu_AddButton(info)	
else	
	info.text = L["No titles available."]
	info.notClickable = 1
	info.isTitle = 1
	UIDropDownMenu_AddButton(info)
	return
end

-- populate with titles
for i = 1, maxtitleID do
	if IsTitleKnown(i) ~= 0 then -- check for validity of player title		
		if i == currentTitle then isChecked = true else isChecked = nil end
		info = {}
		info.text = GetTitleName(i)
		info.func = function() SetCurrentTitle(i) end	
		info.checked = isChecked		
		UIDropDownMenu_AddButton(info);
	end
end

-- add a 'None' option
if currentTitle == 0 or currentTitle == -1 then isChecked = true else isChecked = nil end
info = {}
info.text = _G["NONE"]
info.func = function() SetCurrentTitle(-1) end	
info.checked = isChecked
UIDropDownMenu_AddButton(info)

end


function BRCharTitle:PLAYER_ENTERING_WORLD()	
	UpdateNumOfTitles()
	UIDropDownMenu_Initialize(menuframe, DropdownInitFunction, "MENU")	
	self:UnregisterEvent("PLAYER_ENTERING_WORLD")
	self.PLAYER_ENTERING_WORLD = nil
end

function BRCharTitle:KNOWN_TITLES_UPDATE()	
	UpdateNumOfTitles()
end


function BRCharTitle.obj.OnClick(self, button)	
	if button == "RightButton" then
		ToggleDropDownMenu(1, nil, menuframe, self, 0, 0, nil, self)
	elseif button == "LeftButton" then
		ToggleCharacter("PaperDollFrame")
	end
end

function BRCharTitle:ForceHidePlayerTitleFrame()
	_G["PlayerTitleFrame"]:Hide()
end

BRCharTitle:SecureHook(PlayerTitleFrame, "Show", "ForceHidePlayerTitleFrame")